/***************************************************************************
                          fun21.h  -  description                              
                             -------------------                                         

    version              :                                   
    begin                : Mon Mar 1 1999                                           
    copyright            : (C) 1999 by Henning Busacker                         
    email                : henning.busacker@duesseldorf.netsurf.de                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef FUN21_H
#define FUN21_H

#include "kfun21view.h"
#include <qlayout.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qtimer.h>
#include "qrolistbox.h"
#include "patience.h"
#include "colorprogressbar.h"

/**This is the Game Fun21
  *@author Henning Busacker
  */

class fun21 : public Kfun21View  {
  Q_OBJECT
public: 
	fun21(QWidget *parent = 0);
	virtual ~fun21();
        virtual QStrList* levelNames();
public slots:
	virtual void restart();
 signals:
   /** signalFinished(const char* game, const int points) */
   void signalFinished(const char *,const int);

protected slots:
        virtual void showTotalScore(int);
protected:
	virtual void deal();
        virtual void keyPressEvent ( QKeyEvent * e );

private slots:
	bool handle(int pile);
        void skipCard();
        void slotTakeScore();
        void slotCountDown();
private:
  	void SetupGame();

  	QWidget*	gridframe;
  	QGridLayout*	playground;

  	cardPos*	cards[5];
  	QLabel*		counts[5];
  	bool		ascount[5];
  	QLabel*		totalcount;
/** the multiplier list */
  	QROListbox*	pl;
  	QPushButton*	newcard;
  	QPushButton*	fini;
        QLabel*         totalscore;
        ColorProgressBar* bar;
        QTimer*         timer;
/** the spade king for deco */
  	Card*		dk;
/** the spade ace for deco */
  	Card*		da;
/** holds the skipd card */
  	Card*		away;
/** marks the round as over */
  	bool		gameover;
	int		barinc;
	const static int speedincs [5];
	const static int multiplier[9];
};

#endif






















